#!/usr/bin/python
"""
UCS listener module for synchronization of user
changes with the TecArt Software
"""
__package__ = ""  # workaround for PEP 366

import listener
import os
import errno

import univention.debug as ud
from collections import namedtuple

name = "tecart"
description = "Synchronizes user changes with the TecArt Software"
filter = "(&(!(uid=*$))(!(uidNumber=0))(!(objectClass=univentionHost))(cn=TecArt Users))"

def initialize(): pass
def clean(): pass
def prerun(): pass
def postrun(): pass
def setdata(key, value): pass

def handler(dn, new, old):
	ud.debug(
		ud.LISTENER,
		ud.INFO,
		"Synchronizing users with TecArt: %s %s %s" % (dn, new, old),
	)
	with AsRoot():
		os.system("sudo -u www-data /usr/bin/php /usr/share/tecart/sync_ldap.php")

class AsRoot(object):
	"""
	Temporarily change effective UID to 'root'.
	"""
	def __enter__(self):
		listener.setuid(0)

	def __exit__(self, exc_type, exc_value, traceback):
		listener.unsetuid()
