#!/usr/bin/php
<?php
/*
  Copyright (c) 2015, TecArt GmbH
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  3. All advertising materials mentioning features or use of this software
     must display the following acknowledgement:
     This product includes software developed by the TecArt GmbH.
  4. Neither the name of the TecArt GmbH nor the
     names of its contributors may be used to endorse or promote products
     derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY TECART GMBH ''AS IS'' AND ANY
  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL TECART GMBH BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

$confdir = "/var/lib/univention-appcenter/apps/tecart/conf";

$data_file = "/var/www/tecart/data/data.xml";
$xml = simplexml_load_file($data_file);

function get_config($name) {
	$confdir = "/var/lib/univention-appcenter/apps/tecart/conf";
	return str_replace(array("\r", "\n"), '', file_get_contents("$confdir/$name"));
}

$ad_base = get_config("ldap_base");
$ad_host = get_config("ldap_host");
$ad_port = get_config("ldap_port");
$ad_domain = get_config("ldap_domain");
$ad_password = get_config("ldap.secret");

$ad_connection_info = serialize(array(
	"standard_user" => "1",
	"automatic_email_auth" => 0,
	"sync_auth_user_only" => 0,
	"sync_external_pass" => 0,
	"usergrp_type" => 2,
	"user_group" => "cn=TecArt Users,cn=groups,$ad_base",
	"connection_host" => $ad_host,
	"connection_port" => $ad_port,
	"connection_suffix" => "@$ad_domain",
	"connection_ssl" => 0,
	"connection_tls" => 0,
	"connection_username" => "uid=tecart-user,cn=users,$ad_base",
	"connection_password" => $ad_password,
	"connection_dn" => "$ad_base"
));

$ad_mapping = serialize(array(
	"login" => "uid",
	"home_directory" => "",
	"name" => "displayName",
	"passwd_external" => "",
	"description" => "description",
	"firstname" => "firstname",
	"surname" => "lastname",
	"profession" => "",
	"company" => "organisation",
	"department" => "",
	"address" => "street",
	"postcode" => "postcode",
	"city" => "city",
	"region" => "",
	"country" => "country",
	"tel1" => "",
	"tel2" => "",
	"fax" => "",
	"email" => "mailPrimaryAddress",
	"website" => "",
	"birthday" => "",
	"qualification" => "",
	"qualification_date" => "",
	"satz" => "",
	"ingress_date" => "",
	"discharge_date" => "",
	"leavedays" => "",
	"schoolblock" => "",
	"academic_year" => "",
	"hoursperday" => "",
	"pw_change_next" => "",
	"pw_change_monthly" => "",
	"personnel_no" => "",
	"abbr" => "",
	"middlename" => "",
	"suffix" => "",
	"spouce" => "",
	"children" => "",
	"email1" => "",
	"email2" => "",
	"email3" => "",
	"nickname" => "",
	"screenname1" => "",
	"screenname2" => "",
	"screenname3" => "",
	"home_address1" => "",
	"home_address2" => "",
	"home_postcode" => "",
	"home_city" => "",
	"home_region" => "",
	"home_country" => "",
	"home_website" => "",
	"other_address1" => "",
	"other_address2" => "",
	"other_postcode" => "",
	"other_city" => "",
	"other_region" => "",
	"other_country" => "",
	"phone_work" => "",
	"phone_work2" => "",
	"phone_home" => "",
	"phone_home2" => "",
	"phone_fax" => "",
	"phone_fax_work" => "",
	"phone_pager" => "",
	"phone_mobil" => "",
	"phone_mms" => "",
	"phone_sms" => "",
	"phone_car" => "",
	"phone_radio" => "",
	"phone_assistant" => "",
	"managername" => "",
	"assistantname" => "",
	"customer_id" => "",
	"accountname" => "",
	"gov_id" => "",
	"custom1" => "",
	"custom2" => "",
	"custom3" => "",
	"custom4" => "",
	"custom5" => "",
	"custom6" => "",
	"custom7" => "",
	"custom8" => "",
	"custom9" => "",
	"custom10" => "",
	"cti_phone" => "",
	"cti_msn" => "",
	"cti_user" => "",
	"cti_pass" => "",
	"email_login" => "",
	"email_type" => "",
	"email_name" => "",
	"email_pop3_server" => "",
	"email_smtp_server" => ""
));

foreach($xml->table as $table) {
	if ((string)$table->attributes()["name"] === 'globaloptions') {
		$sync = $table->addChild("row");
		$syncint = $table->addChild("row");
		$conn = $table->addChild("row");
		$map  = $table->addChild("row");

		$sync->addAttribute('var', 'cron_sync_ad');
		$syncint->addAttribute('var', 'cron_sync_ad_intval');
		$conn->addAttribute('var', 'ad_connection_info');
		$map->addAttribute('var', 'ad_mapping');

		$sync->addAttribute('value', 1);
		$syncint->addAttribute('value', 1);
		$conn->addAttribute('value', $ad_connection_info);
		$map->addAttribute('value', $ad_mapping);

		$conn->addAttribute('serialized', 1);
		$map->addAttribute('serialized', 1);
	}
}

$xml->asXml($data_file);


$lists_file = "/var/www/tecart/data/lists.xml";
$lists_xml = simplexml_load_file($lists_file);

foreach($lists_xml->list as $list) {
	if ((string)$list->attributes()["name"] === 'ad_schema') {
		foreach ($list->item as $item) {
			if ((string)$item->attributes()["key"] === 'mail') {
				$item->attributes()["key"] = "mailPrimaryAddress";
			}
			if ((string)$item->attributes()["key"] === 'sAMAccountName') {
				$item->attributes()["key"] = "uid";
			}
			if ((string)$item->attributes()["key"] === 'givenName') {
				$item->attributes()["key"] = "firstname";
			}
			if ((string)$item->attributes()["key"] === 'sn') {
				$item->attributes()["key"] = "lastname";
			}
		}
	}
}

$lists_xml->asXml($lists_file);

