#!/usr/bin/python

import time, sys, os, os.path, glob, random, subprocess, string, socket, base64, shutil, signal, hashlib

print(time.strftime('%H:%M:%S')+': Starting')

os.chdir(os.path.dirname(os.path.realpath(sys.argv[0])))

print(sys.argv)

CONFIG = {}
CONFIG['tcucd_nodes_count'] = '1'
CONFIG['soffice_path'] = False
CONFIG['python_path'] = False
CONFIG['tcucd_dir'] = False
CONFIG['tcucd_log_dir'] = False
CONFIG['lock_file'] = False
CONFIG['convert_path'] = False
CONFIG['soffice_port'] = '2002'

for elem in sys.argv:
    print(elem)
    arr = elem.split('=', 1)
    if len(arr)>1 and arr[1].strip()!='':
        CONFIG[arr[0]] = arr[1]
print(CONFIG)

if not CONFIG['soffice_path']: sys.exit()
if not CONFIG['python_path']: sys.exit()
if not CONFIG['tcucd_dir']: sys.exit()
if not CONFIG['tcucd_log_dir']: sys.exit()
if not CONFIG['lock_file']: sys.exit()
if not CONFIG['convert_path']: sys.exit()

#NODE_ID
char_set = string.ascii_uppercase + string.digits
NODE_ID  = ''.join(random.sample(char_set,6))

#COMMON_BASE_DIR = CONFIG['converter_base_dir']
WORKER_DIR      = CONFIG['tcucd_dir'] + 'worker'
IN_DIR          = CONFIG['tcucd_dir'] + '1infiles'
LOG_DIR         = CONFIG['tcucd_log_dir']
MAX_NODES_COUNT = int(CONFIG['tcucd_nodes_count'])

OWN_LOCK_FILE   = CONFIG['lock_file']
OWN_WORK_FILE   = WORKER_DIR + '/worker_' + NODE_ID
LOG_FILE_1      = CONFIG['tcucd_log_dir'] + '/tcucd_success.log'
LOG_FILE_2      = CONFIG['tcucd_log_dir'] + '/tcucd_convert_errors.log'
LOG_FILE_3      = CONFIG['tcucd_log_dir'] + '/tcucd_ooffice.log'
LOG_FILE_4      = CONFIG['tcucd_log_dir'] + '/tcucd_tcucd.log'

LOG_SUCCESS     = 1
LOG_ERROR       = 2
LOG_OOFFICE     = 3
LOG_TCUCD       = 4

WORKING         = True
RUNNING         = True
OOPROCESS       = False

OO_STARTSTOP_PAUSE = 2
WAIT_FOR_OO_PAUSE = 5
NOT_WORKING_PAUSE = 1
UNOCONV_WAIT = 300
UNOCONV_WAIT_PAUSE = 0.2
WORKER_TIMEOUT = 115
FILES_RETRY = 3

if 'libreoffice' in os.path.realpath(CONFIG['soffice_path']):
    LIBREOFFICE = True
else:
    LIBREOFFICE = False

def writelog(message, to_file = 0):
    file = False
    if to_file == 1:
        #success convert
        file = open(LOG_FILE_1, 'a')
    if to_file == 2:
        #error convert
        file = open(LOG_FILE_2, 'a')
    if to_file == 3:
        #restart ooffice
        file = open(LOG_FILE_3, 'a')
    if to_file == 4:
        #restart tcucd
        file = open(LOG_FILE_4, 'a')

    if file != False:
        file.write(str(os.getpid())+': ' + time.strftime('%y-%m-%d %H:%M:%S')+': TCUCD: '+str(message) + "\n")
        file.close()

    print(time.strftime('%H:%M:%S')+': '+str(message))

def update_file(filename):
    if filename == OWN_LOCK_FILE:
        lf = open(OWN_LOCK_FILE, 'w+')
        lf.write(str(os.getpid()))
        lf.close()
        return False
    try:
        open(filename, 'w+').close()
        #writelog('UPDATED: '+filename)
        return True
    except IOError as e:
        pass

def synchronize():
    global WORKING, RUNNING
    locks = glob.glob(WORKER_DIR + '/worker_*')
    lock_count = len(locks)

    for lock in locks:
        try:
            if os.path.getmtime(lock) < time.time() - WORKER_TIMEOUT and lock != OWN_WORK_FILE:
                os.unlink(lock)
                writelog('WORKER DELETED: ' + lock)
                lock_count = lock_count - 1
        except OSError as e:
            pass
    if lock_count < MAX_NODES_COUNT and not os.path.exists(OWN_WORK_FILE):
        update_file(OWN_WORK_FILE)
        update_file(OWN_LOCK_FILE)
        writelog('WORKER ADDED: '+ OWN_WORK_FILE)
        writelog('Starting')
        WORKING = True
    elif lock_count > MAX_NODES_COUNT and os.path.exists(OWN_WORK_FILE):
        writelog('OWN WORKER DELETED '+ OWN_WORK_FILE)
        os.unlink(OWN_WORK_FILE)
        WORKING = False
    elif not os.path.exists(OWN_LOCK_FILE):
        RUNNING = False
        WORKING = False
    elif not os.path.exists(OWN_WORK_FILE):
        #service wurde von einem anderen node deaktiviert
        WORKING = False
    else:
        update_file(OWN_WORK_FILE)
        update_file(OWN_LOCK_FILE)
        RUNNING = True
        WORKING = True

def oo_start():
    global OOPROCESS, CONFIG, LIBREOFFICE, NODE_ID
    if OOPROCESS != False:
        return

    env = os.environ.copy()
    print(env)
    print(LIBREOFFICE)
    env['UserInstallation'] = 'file:///tmp/oof_'+NODE_ID+'/.openoffice.org/3'
    if LIBREOFFICE:
        OOPROCESS = subprocess.Popen([CONFIG['soffice_path'], "--headless", "--invisible", "--nocrashreport", "--nodefault", "--nofirststartwizard", "--nologo", "--norestore", "--accept=socket,host=localhost,port="+CONFIG['soffice_port']+";urp;StarOffice.ComponentContext" ], env=env)
    else:
        OOPROCESS = subprocess.Popen([CONFIG['soffice_path'], "-headless",  "-invisible",  "-nocrashreport",  "-nodefault",  "-nofirststartwizard",  "-nologo",  "-norestore",  "-accept=socket,host=localhost,port="+CONFIG['soffice_port']+";urp;StarOffice.ComponentContext" ], env=env)
    writelog('Start', LOG_OOFFICE)
    writelog('Start Waiting ' + str(OO_STARTSTOP_PAUSE))
    time.sleep(OO_STARTSTOP_PAUSE)


def oo_stop():
    global OOPROCESS
    print('STOP', OOPROCESS)
    if OOPROCESS == False:
        return
    pid = OOPROCESS.pid
    subprocess.call(['kill','-15',str(pid)])
    subprocess.call(['killall','soffice'])
    if os.path.exists('/tmp/oof/'):
        shutil.rmtree('/tmp/oof/')
    writelog('Stop', LOG_OOFFICE)
    writelog('Stop Waiting ' + str(OO_STARTSTOP_PAUSE))
    time.sleep(OO_STARTSTOP_PAUSE)
    OOPROCESS = False

def oo_restart():
    global OOPROCESS
    oo_stop()
    oo_start()

def oo_is_running():
    global OOPROCESS, CONFIG
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.settimeout(WAIT_FOR_OO_PAUSE)
    writelog('Check for connection')
    try:
        s.connect(('localhost', int(CONFIG['soffice_port'])))
        data = s.recv(1)
        writelog(data);
    except Exception as e:
        writelog('No runnig instance found', LOG_OOFFICE)
        print('closed')
        return False
    s.close()
    return True

def check_version(md5_orig = False):
    check_content = open(__file__).read().encode('utf-8')
    md5_content = hashlib.md5(check_content).hexdigest()
    if md5_orig:
        return md5_orig==md5_content
    else:
        return md5_content

def terminate():
    if os.path.exists(OWN_LOCK_FILE):
        os.unlink(OWN_LOCK_FILE)
    if os.path.exists(OWN_WORK_FILE):
        os.unlink(OWN_WORK_FILE)
    oo_stop()
    writelog('Killed')
    print('Exiting on user request')

def run_process(params):
    writelog(params, LOG_TCUCD);
    writelog('Subprocess startet', LOG_TCUCD);
    conv = subprocess.Popen(params)
    wait = 0
    while wait < UNOCONV_WAIT:
        if round(wait) == wait:
            update_file(OWN_LOCK_FILE)
        if conv.poll() != None:
            if conv.returncode > 0:
                writelog("Subprocess " + str(params) +' ended unexpected '+str(conv.returncode), LOG_TCUCD)
                return False
            writelog('Subprocess ended without errors after '+str(wait), LOG_TCUCD);
            return True
        writelog("Waiting for "+params[1], False)
        wait += UNOCONV_WAIT_PAUSE
        time.sleep(UNOCONV_WAIT_PAUSE)
    writelog('Subprocess ended with timeout after '+str(wait), LOG_TCUCD);
    pid = conv.pid
    subprocess.call(['kill','-15',str(pid)])
    return False

### Main entrance
if __name__ == '__main__':
    writelog('Starting TCUCD', LOG_TCUCD);
    try:
        if os.path.exists(OWN_LOCK_FILE) and os.path.getmtime(OWN_LOCK_FILE) > time.time() - 10:
            writelog('Allready running since ' + str(os.path.getmtime(OWN_LOCK_FILE)), LOG_TCUCD)
            sys.exit(0)
        elif os.path.exists(OWN_LOCK_FILE):
            with open(OWN_LOCK_FILE, 'r') as f:
                r = f.read()
                print('killing ', r)
                os.kill(int(r), signal.SIGTERM)
            os.unlink(OWN_LOCK_FILE)
    except Exception as e:
        writelog(e, LOG_TCUCD)
        if os.path.exists(OWN_LOCK_FILE):
            writelog(str(os.path.getmtime(OWN_LOCK_FILE)))
        pass

    if not os.path.isdir(WORKER_DIR):
        os.makedirs(WORKER_DIR,0o777)
    if not os.path.isdir(IN_DIR):
        os.makedirs(IN_DIR,0o777)
    if not os.path.isdir(LOG_DIR):
        os.makedirs(LOG_DIR,0o777)

    update_file(OWN_LOCK_FILE)
    #oo_start()
    writelog('Started', LOG_TCUCD)

    global_timer = 1;
    md5_script = check_version()

    try:
        while RUNNING:
            global_timer += 1

            synchronize()
            if not RUNNING: break

            if round(time.time()) % 600 == 0:
                #Verzeichnis aufraeumen
                delfiles = glob.glob(IN_DIR + '/*.pdf')
                for file in delfiles:
                    os.unlink(file)
                delfiles = glob.glob(IN_DIR + '/*_working.odt')
                for file in delfiles:
                    os.unlink(file)
                delfiles = glob.glob(IN_DIR + '/*_update.odt')
                for file in delfiles:
                    os.unlink(file)

            if round(time.time()) % 600 == 0 and not check_version(md5_script):
                writelog('Update found', LOG_TCUCD);
                print('Update found')
                break

            if not WORKING:
                writelog('NO WORKER FOUND: DELAYING')
                update_file(OWN_LOCK_FILE)
                oo_stop()
                time.sleep(NOT_WORKING_PAUSE)
                continue

            if not oo_is_running(): oo_restart()

            infiles = sorted(glob.glob(IN_DIR + '/*_prepare'))
            if len(infiles) == 0:
                writelog('Nothing to do')
                time.sleep(NOT_WORKING_PAUSE)
                continue;

            for file in infiles:
                if os.path.exists(file) and os.path.isfile(file):
                    writelog('Start converting '+file, LOG_TCUCD);
                    try:
                        os.rename(file, file + '_working.odt')
                    except Exception as e:
                        continue
                    writelog(file + ' working', LOG_TCUCD)
                    file_error_count = -1
                    while True:
                        uc_executed = False
                        flags = os.path.basename(file).split('_',3)
                        formats = flags[1].split(',')

                        target_name = flags[0]
                        file_real = base64.b64decode(target_name).decode("utf-8")
                        if os.path.exists(file + '_update.odt'):
                            os.unlink(file + '_update.odt')

                        #Create updated odt
                        if 'odt' in formats:
                            while not run_process([CONFIG['python_path'], 'tc_unoconv.py','-T','10','-f','odt','-o',file+'_update','-s','localhost','-p',CONFIG['soffice_port'],file + '_working.odt']):
                                if not oo_is_running(): oo_restart()
                                file_error_count += 1
                                writelog(file_error_count)
                                writelog(FILES_RETRY)
                                if (file_error_count >= FILES_RETRY):
                                    try:
                                        writelog(file + ' error while updateing odt: FILES_RETRY reached: ' + file_real, LOG_ERROR)
                                        os.rename(file + '_update.odt', file + '_error.odt')
                                    except Exception as e:
                                        pass
                                    break

                            try:
                                time.sleep(UNOCONV_WAIT_PAUSE)
                                shutil.move(file + '_update.odt', file_real + '.odt')
                                pass
                            except Exception as e:
                                writelog(file + '_update.odt' + ' error: could not move to ' + file_real + '.odt ' + str(e), LOG_ERROR)
                                writelog(file + '_update.odt' + ' error: could not move to ' + file_real + str(e))
                                open(file_real + '.odt.err', 'a').close()
                                break
                            writelog(file, LOG_SUCCESS)

                        #Create pdf only if neccessary
                        if 'pdf' in formats:
                            file_error_count = 0
                            if os.path.exists(file + '_working.pdf'):
                                os.unlink(file + '_working.pdf')
                            while not run_process([CONFIG['python_path'], 'tc_unoconv.py','-T','10','-eSelectPdfVersion=1','-f','pdf','-s','localhost','-p',CONFIG['soffice_port'],file + '_working.odt']):
                                if not oo_is_running(): oo_restart()
                                file_error_count += 1

                                if (file_error_count >= FILES_RETRY):
                                    try:
                                        writelog(file + ' error while converting to pdf: FILES_RETRY reached: ' + file_real, LOG_ERROR)
                                        os.rename(file + '_working.odt', file + '_error.odt')
                                    except Exception as e:
                                        pass
                                    break
                            try:
                                time.sleep(UNOCONV_WAIT_PAUSE)
                                shutil.move(file + '_working.pdf', file_real + '.pdf')
                            except Exception as e:
                                writelog(file + '_working.odt' + ' error: could not move to ' + file_real + '.pdf ' + str(e), LOG_ERROR)
                                writelog(file + '_working.pdf' + ' error: could not move to ' + file_real + str(e))
                                open(file_real + '.pdf.err', 'a').close()
                                break
                            writelog(file, LOG_SUCCESS)

                        try:
                            os.unlink(file + '_working.odt')
                            #os.unlink(file + '_working.pdf')
                            pass
                        except OSError as e:
                            writelog(e, LOG_ERROR)
                        writelog(file + ' ready ' +file_real, LOG_SUCCESS)
                        break

            time.sleep(NOT_WORKING_PAUSE)

    except KeyboardInterrupt as e:
        pass

    terminate()

